# Třídící algoritmus heapsort za použití haldy z Pythonu
#
# Jan Kybic, 2016

import heapq

def heap_sort(a):
  """ Sorts an array 'a' in place. Needs an auxiliary array"""
  h=a.copy()
  heapq.heapify(h)
  for i in range(len(a)):
    a[i]=heapq.heappop(h)


# ------------------------------------ test part ----------------------------------
def main():
  import random
  import sorting_experiments

  a=[random.randrange(100) for i in range(10)]
  print(a)
  heap_sort(a)
  print(a)

  sorting_experiments.test_sort(f=heap_sort)  

if __name__=="__main__":
   main()
  
